---------------------------------------------------
-- IM_Filter_DropDown_Load
---------------------------------------------------
function IM_Filter_DropDown_Load()

	--rarity
	UIDropDownMenu_Initialize(IM_FilterPurgeRare_DropDown, IM_FilterPurgeRare_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_FilterPurgeRare_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_RARITY);
	UIDropDownMenu_JustifyText("LEFT", IM_FilterPurgeRare_DropDown)	
end



---------------------------------------------------
-- IM_FilterPurgeRare_DropDown_Initialize
---------------------------------------------------
function IM_FilterPurgeRare_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_RARITY), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_RARITY[i].name;
		info.func = IM_FilterPurgeRare_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end


---------------------------------------------------
-- IM_FilterPurgeRare_DropDown_OnClick
---------------------------------------------------
function IM_FilterPurgeRare_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_FilterPurgeRare_DropDown, this:GetID());
end



---------------------------------------------------
-- IM_SearchFrame_Close
---------------------------------------------------
function IM_FilterFrame_Close()

	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Rarity_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_RARITY);


end



---------------------------------------------------
-- IM_SearchFrame_Close
---------------------------------------------------
function IM_FilterFrame_DoPurge()
local storeRarity;

	--grab rarity
	if( ItemsMatrix_DROPDOWN_LIST_RARITY[UIDropDownMenu_GetSelectedID(IM_FilterPurgeRare_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_RARITY[UIDropDownMenu_GetSelectedID(IM_FilterPurgeRare_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				storeRarity = nil;
			else
				storeRarity = sortType;
			end
			
			
	end
	
	
	if(storeRarity and IMDB and IM_Realm and IMDB[IM_Realm]) then
	
		--do the loop
		for index, value in IMDB[IM_Realm] do
	
			--make sure it exists and it has a quality number
			if(IMDB[IM_Realm][index] and IM_GetData(index,"quality")) then
			
				if(tonumber(IM_GetData(index,"quality")) == tonumber(storeRarity)) then
					
					--the color matches so delete it
					IMDB[IM_Realm][index] = nil; 
				end
			
			end
	
		end
		
		--call a refresh
		ItemsMatrix_Refresh();
		
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000ItemsMatrix: Items have been deleted successfully.|r");
	
	
	else
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000ItemsMatrix: Incorrect or empty rarity selection.|r");
	
	end
	
	

end


---------------------------------------------------
-- IM_CheckRarity
---------------------------------------------------
function IM_CheckRarity_Filter(sQuality)

	if(not sQuality) then
		return nil;
	end
	
	--convert to number
	sQuality = tonumber(sQuality);
	
	--make sure we have options
	if(IM_Options and ItemsMatrix_User and IM_Options[ItemsMatrix_User] and IM_Options[ItemsMatrix_User].Filters) then
 
 
 		--make sure we watch for unknowns/other
 		if(sQuality > -1 and sQuality < 6) then
 		
			if(IM_Options[ItemsMatrix_User].Filters[sQuality] and IM_Options[ItemsMatrix_User].Filters[sQuality] == 1) then

				return 1; --return yes
			else
				return nil;
			end
 		
 		
 		else
 			--check unknowns
 			if(IM_Options[ItemsMatrix_User].Filters[99] and IM_Options[ItemsMatrix_User].Filters[99] == 1) then
 
 				return 1; --return yes
 			else
 				return nil;
			end
 		
 		
 		end
 

 
 	else
 	
 		return nil;
 	end


end
