---------------------------------------------------------------------------------
--GLOBAL VARIABLES
ItemsMatrix_Version = 16;			--version
ItemsMatrix_Database_Version = 2;		--Database version
ItemsNet_Version = 1;				--ItemsNet Version
ItemsMatrix_User = nil;				--Stores the playername
IM_Realm = nil;					--Stores the current realm the user is playing on.
IM_LastPrice = 0;				--Stores the money value from scanned tooltips
IM_Database_Upgrade = 0;			--switch to denote if player is required to do a mandatory reset
ITEMMATIX_ITEM_HEIGHT = 16;			--how high to make each item button
ITEMMATIX_ITEM_SHOWN = 23;			--how many items to show on the itemsmatrix window
IM_SearchActivated = 0;				--switch for search initiated
IM_WAIT_TIME = 15;				--the amount of time between each message sent
IMItemsNet_ChannelNumber = 0;			--ItemsNet Channel Number
IM_ALERT_ON = 0;				--boolean for ItemsNet channel alert.
IM_CheckTooltip = 1;				--Checks for current state of tooltip
IM_CheckTimer = 0;				--timer for checks on tooltips
---------------------------------------------------------------------------------

StaticPopupDialogs["IM_CLEARDATA_CONFIRM"] = {
		text = TEXT("|c00FF0000\nThis is Irreverable!\n\nAre you sure you want to clear all data?\n\nNOTE: This action cannot be undone!"),
		button1 = TEXT(OKAY),
		button2 = TEXT(CANCEL),
		OnAccept = function()
		
			--erase
			ItemsMatrixFrame:Hide();
			IMDB = nil;
			IMDB = { };

			--make sure we have the server listed
			if(IMDB and IM_Realm and not IMDB[IM_Realm] ) then
				IMDB[IM_Realm] = { };			
			end
			
			IM_DisplayIndices = nil;
			
			ItemsMatrix_Refresh();
			
			if(IM_Options and ItemsMatrix_User and IM_Options[ItemsMatrix_User]) then
			
				IM_Options["DBVersion"] = ItemsMatrix_Database_Version;
				
				IM_Database_Upgrade = 0; --reset again
				
			end
			

			if( DEFAULT_CHAT_FRAME ) then
				DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000ItemsMatrix: Data has been successfully reset.|r");
			end
		
		end,
		showAlert = 1,
		timeout = 0,
		exclusive = 1,
		whileDead = 1,
		interruptCinematic = 1
};



StaticPopupDialogs["IM_PURGEDATA_CONFIRM"] = {
		text = TEXT("|c00FF0000\nThis is Irreverable!\n\nAre you sure you want to purge the data?\n\nNOTE: This action cannot be undone!"),
		button1 = TEXT(OKAY),
		button2 = TEXT(CANCEL),
		OnAccept = function()
		
			IM_FilterFrame_DoPurge();
		end,
		showAlert = 1,
		timeout = 0,
		exclusive = 1,
		whileDead = 1,
		interruptCinematic = 1
};


StaticPopupDialogs["IM_DATA_INCOMPATIBLE"] = {
		text = TEXT("|c00FF0000\nYour database is old!\n\nYour current database is incompatible!\n\nPress 'Okay' to PURGE your database!"),
		button1 = TEXT(OKAY),
		button2 = TEXT(CANCEL),
		OnAccept = function()
		
			--erase
			ItemsMatrixFrame:Hide();
			IMDB = nil;
			IMDB = { };

			--make sure we have the server listed
			if(IMDB and IM_Realm and not IMDB[IM_Realm] ) then
				IMDB[IM_Realm] = { };			
			end
			
			IM_DisplayIndices = nil;
			
			ItemsMatrix_Refresh();
			
			if(IM_Options and ItemsMatrix_User and IM_Options[ItemsMatrix_User]) then
			
				IM_Options["DBVersion"] = ItemsMatrix_Database_Version;
				
			end
			

			if( DEFAULT_CHAT_FRAME ) then
				DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000ItemsMatrix: Database has been purged.|r");
			end
			
			
			IM_Database_Upgrade = 0; --reset again
					
					
		end,
		showAlert = 1,
		timeout = 0,
		exclusive = 1,
		whileDead = 1,
		interruptCinematic = 1
};


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ItemsMatrix_Timer_OnLoad
-----------------------------------------------
function ItemsMatrix_Timer_OnLoad()
	  ItemsMatrix_Timer_Schedule.Todo = {};
	  ItemsMatrix_Timer_Schedule.Todo.n = 0;
end


---------------------------------------------------
-- ItemsMatrix_Timer_OnUpdate
-----------------------------------------------
function ItemsMatrix_Timer_OnUpdate()

	  while(ItemsMatrix_Timer_Schedule.Todo[1] and 
		ItemsMatrix_Timer_Schedule.Todo[1].time <= GetTime()) do
	    local todo = table.remove(ItemsMatrix_Timer_Schedule.Todo,1);
	    if(todo.args) then
	      todo.handler(unpack(todo.args));
	    else
	      todo.handler();
	    end
	  end
		
end


---------------------------------------------------
-- ItemsMatrix_Timer_Add
-----------------------------------------------
function ItemsMatrix_Timer_Add(when,handler,...)
	  local todo = {};
	  todo.time = when + GetTime();
	  todo.handler = handler;
	  todo.args = arg;
	  local i = 1;
	  while(ItemsMatrix_Timer_Schedule.Todo[i] and
		ItemsMatrix_Timer_Schedule.Todo[i].time < todo.time) do
	    i = i + 1;
	  end
	  table.insert(ItemsMatrix_Timer_Schedule.Todo,i,todo);
end


---------------------------------------------------
-- IM_strsplit
-----------------------------------------------
function IM_strsplit(delimiter, text)	
	  local list = {};
	  local pos = 1;
	  if strfind("", delimiter, 1) then -- this would result in endless loops
	    --error("delimiter matches empty string!")
	  end
	  while 1 do
	  
	  	if(text ~= nil) then
	  	
		    local first, last = strfind(text, delimiter, pos)
		    if first then -- found?
		    
		    	if(strsub(text, pos, first-1) and strsub(text, pos, first-1) ~= "") then
		      		tinsert(list, strsub(text, pos, first-1))
		      	end
		      	pos = last+1
		      
		      
		    else
		    	if(strsub(text, pos)) then
		      		tinsert(list, strsub(text, pos))
		      	end
		      break
		    end
		   
		   
		   else
		   	break
		    
		end
	  end
	  return list
  
end
