QUICKCALC_VERSION = "1.4";

BINDING_HEADER_QUICKCALC = "QuickCalc (automatic)";
BINDING_NAME_QC_NUMLOCK = "Numlock";
BINDING_NAME_QC_CLEAR = "Clear";

BINDING_NAME_QC_DIV = "Divide";
BINDING_NAME_QC_MUL = "Multiply";
BINDING_NAME_QC_SUB = "Subtract";
BINDING_NAME_QC_ADD = "Add";
BINDING_NAME_QC_EQ = "Equals";

BINDING_NAME_QC_0 = "Digit 0";
BINDING_NAME_QC_1 = "Digit 1";
BINDING_NAME_QC_2 = "Digit 2";
BINDING_NAME_QC_3 = "Digit 3";
BINDING_NAME_QC_4 = "Digit 4";
BINDING_NAME_QC_5 = "Digit 5";
BINDING_NAME_QC_6 = "Digit 6";
BINDING_NAME_QC_7 = "Digit 7";
BINDING_NAME_QC_8 = "Digit 8";
BINDING_NAME_QC_9 = "Digit 9";

BINDING_NAME_QC_DEC = "Decimal";

QUICKCALC_REMAPPED = { };
QUICKCALC_REMAPPED.NUMLOCK = "";
QUICKCALC_REMAPPED.HOME = "";
QUICKCALC_REMAPPED.END = "";

QUICKCALC_REMAPPED.NUMPADDIVIDE = "";
QUICKCALC_REMAPPED.NUMPADMULTIPLY = "";
QUICKCALC_REMAPPED.NUMPADMINUS = "";
QUICKCALC_REMAPPED.NUMPADPLUS = "";
QUICKCALC_REMAPPED.ENTER = "";

QUICKCALC_REMAPPED.NUMPAD0 = "";
QUICKCALC_REMAPPED.NUMPAD1 = "";
QUICKCALC_REMAPPED.NUMPAD2 = "";
QUICKCALC_REMAPPED.NUMPAD3 = "";
QUICKCALC_REMAPPED.NUMPAD4 = "";
QUICKCALC_REMAPPED.NUMPAD5 = "";
QUICKCALC_REMAPPED.NUMPAD6 = "";
QUICKCALC_REMAPPED.NUMPAD7 = "";
QUICKCALC_REMAPPED.NUMPAD8 = "";
QUICKCALC_REMAPPED.NUMPAD9 = "";

QUICKCALC_REMAPPED.NUMPADDECIMAL = "";

QUICKCALC_SHOWNTEXT = "0";
QUICKCALC_RUNNINGTOTAL = "";
QUICKCALC_PREVIOUSKEYTYPE = "none";
QUICKCALC_PREVIOUSOP = "";

QUICKCALC_CONSOLE_LAST_ANS = "0";

function quick_calc_initialize()
	-- add our very first chat command!
	SlashCmdList["QUICKCALC"] = quick_calc_command;
	SLASH_QUICKCALC1 = "/quickcalc";
	SLASH_QUICKCALC2 = "/qcalc";
	SLASH_QUICKCALC3 = "/calc";
	SLASH_QUICKCALC4 = "/=";

      quick_calc_titletext : SetText ( "QuickCalc v" .. QUICKCALC_VERSION );
	quick_calc_showntext : SetText ( QUICKCALC_SHOWNTEXT );
end

function quick_calc_command(msg)
	-- this function handles our chat command
	if (msg == nil or msg == "") then
		quick_calc_display()
		return nil;
	end

	local expression = msg;

	newexpression = quick_calc_parse(expression);
	--ChatFrame1:AddMessage("ne = " .. newexpression);

	local result = quick_calc_calculate(newexpression);

	QUICKCALC_CONSOLE_LAST_ANS = result;

	--message(result);
	ChatFrame1:AddMessage("QuickCalc Result: " .. expression .. " = " .. result, 1.0, 1.0, 0.5);
end

function quick_calc_calculate(expression)
	local tempvar = "QCExpVal";

	setglobal(tempvar, nil);
	RunScript(tempvar .. "=(" .. expression .. ")");
	local result = getglobal(tempvar);

	return result;
end

function quick_calc_parse(expression)
	local ismoney = false;

	newexpression = expression

	local newexpression = string.gsub(newexpression, "ans", QUICKCALC_CONSOLE_LAST_ANS);

	-- g s c
	local newexpression = string.gsub(newexpression, "%d+g%d+s%d+c", function (a)
			ismoney = true;
			return FromGSC(a);
		end );

	-- g s
	local newexpression = string.gsub(newexpression, "%d+g%d+s", function (a)
			ismoney = true;
			return FromGSC(a);
		end );


	-- g   c
	local newexpression = string.gsub(newexpression, "%d+g%d+c", function (a)
			ismoney = true;
			return FromGSC(a);
		end );

	-- g         allows #.#
	local newexpression = string.gsub(newexpression, "%d+%.?%d*g", function (a)
			ismoney = true;
			return FromGSC(a);
		end );

	--   s c
	local newexpression = string.gsub(newexpression, "%d+s%d+c", function (a)
			ismoney = true;
			return FromGSC(a);
		end );

	--   s       allows #.#
	local newexpression = string.gsub(newexpression, "%d+%.?%d*s", function (a)
			ismoney = true;
			return FromGSC(a);
		end );

	--     c
	local newexpression = string.gsub(newexpression, "%d+c", function (a)
			ismoney = true;
			return FromGSC(a);
		end );


	if (ismoney) then
		newexpression = "ToGSC(" .. newexpression .. ")";
	end

	return newexpression
end

function quick_calc_display()
	if (quick_calc_window:IsVisible()) then
		quick_calc_window:Hide();
	else
		quick_calc_window:Show();
	end
end

function quick_calc_rebind()
	for x = 1, GetNumBindings() do
		currBinding = GetBinding(x);
		keyone, keytwo = GetBindingKey(currBinding);

		for key,value in pairs(QUICKCALC_REMAPPED) do
			if (keyone == key or keytwo == key) then
				QUICKCALC_REMAPPED[key] = currBinding;
			end
		end

	end

	--steal numlock away from anything else
	SetBinding("NUMLOCK", "QC_NUMLOCK");
	SetBinding("HOME", "QC_CLEAR");
	SetBinding("END", "QC_CLOSE");

	--set numlock on keys
	SetBinding("NUMPADDIVIDE", "QC_DIV");
	SetBinding("NUMPADMULTIPLY", "QC_MUL");
	SetBinding("NUMPADMINUS", "QC_SUB");
	SetBinding("NUMPADPLUS", "QC_ADD");
	SetBinding("ENTER", "QC_EQ");
	SetBinding("NUMPAD0", "QC_0");
	SetBinding("NUMPAD1", "QC_1");
	SetBinding("NUMPAD2", "QC_2");
	SetBinding("NUMPAD3", "QC_3");
	SetBinding("NUMPAD4", "QC_4");
	SetBinding("NUMPAD5", "QC_5");
	SetBinding("NUMPAD6", "QC_6");
	SetBinding("NUMPAD7", "QC_7");
	SetBinding("NUMPAD8", "QC_8");
	SetBinding("NUMPAD9", "QC_9");
	SetBinding("NUMPADDECIMAL", "QC_DEC");

	SaveBindings();
end

function quick_calc_unbind()

	for key,value in pairs(QUICKCALC_REMAPPED) do
		SetBinding(key, value);
		QUICKCALC_REMAPPED[key] = "";
	end

	SaveBindings();
end

function quick_calc_onkeydown()
	key = arg1;
	message(key);
end

function quick_calc_statekey(key)
	--message(key);
	currText = QUICKCALC_SHOWNTEXT;

		if (key == ".") then
			s,e = string.find(currText, "c");
			if (s == nil and e == nli) then
				s,e = string.find(currText, "s");

				if (s == nil and e == nil) then
					s,e = string.find(currText, "g");
	
					if (s == nil and e == nil) then
						s,e = string.find(currText, "%.");

						if (s == nil and e == nil) then
							currText = currText .. "."
						end
					end
				end
			end
		elseif (key == "+/-") then
			if (currText ~= "0") then
				s = string.find(currText, "-");
	
				if (s == nil) then
					currText = "-" .. currText;
				else
					currText = string.sub(currText, 2);
				end
			end
		elseif (key == "C" or key == "c") then
			currText = "0";
			QUICKCALC_RUNNINGTOTAL = "";
			QUICKCALC_PREVIOUSKEYTYPE = "none";
			QUICKCALC_PREVIOUSOP = "";
		elseif (key == "gold") then
			s,e = string.find(currText, "c");
			if (s == nil and e == nli) then
				s,e = string.find(currText, "s");

				if (s == nil and e == nil) then
					s,e = string.find(currText, "g");
	
					if (s == nil and e == nil) then
						currText = currText .. "g";
					end
				end
			end
		elseif (key == "silver") then
			s,e = string.find(currText, "c");
			if (s == nil and e == nil) then
				s,e = string.find(currText, "s");

				if (s == nil and e == nil) then
					currText = currText .. "s";
				end
			end
		elseif (key == "copper") then
			s,e = string.find(currText, "c");
			if (s == nil and e == nil) then
				currText = currText .. "c";
			end
		end

	QUICKCALC_PREVIOUSKEYTYPE = "state";
	QUICKCALC_SHOWNTEXT = currText;
	quick_calc_showntext:SetText(QUICKCALC_SHOWNTEXT);
end

function quick_calc_funckey(key)
	--message(key);
	currText = QUICKCALC_SHOWNTEXT;

	if (QUICKCALC_PREVIOUSKEYTYPE=="none" or QUICKCALC_PREVIOUSKEYTYPE=="num" or QUICKCALC_PREVIOUSKEYTYPE=="state") then
			--ChatFrame1:AddMessage("bleh:" .. QUICKCALC_RUNNINGTOTAL .. QUICKCALC_PREVIOUSOP .. currText);
			--ChatFrame1:AddMessage("bleh:" .. quick_calc_parse(QUICKCALC_RUNNINGTOTAL .. QUICKCALC_PREVIOUSOP .. currText));
			if (key == "/" or key == "*" or key == "-" or key == "-" or key == "+" or key == "^") then
				---if (QUICKCALC_PREVIOUSOP~="=") then				
					
				if (QUICKCALC_PREVIOUSOP~="") then
					temp = quick_calc_parse(QUICKCALC_RUNNINGTOTAL .. QUICKCALC_PREVIOUSOP .. currText);
					currText = quick_calc_calculate(temp);
				end
				QUICKCALC_RUNNINGTOTAL = currText;
				QUICKCALC_PREVIOUSOP = key;
			elseif (key == "=") then
				if (QUICKCALC_PREVIOUSOP~="=" and QUICKCALC_PREVIOUSOP~="") then
					temp = quick_calc_parse(QUICKCALC_RUNNINGTOTAL .. QUICKCALC_PREVIOUSOP .. currText);
					--ChatFrame1:AddMessage("MOO:" .. temp);
					currText = quick_calc_calculate(temp);
					QUICKCALC_RUNNINGTOTAL = currText;
					QUICKCALC_PREVIOUSOP="=";
				end
			else
			
			end
				
	else --must be a func key, a second+ time
		if (key == "/" or key == "*" or key == "-" or key == "-" or key == "+" or key == "^") then
			QUICKCALC_PREVIOUSOP=key;
		else
			QUICKCALC_PREVIOUSOP="";
		end 
	end
	QUICKCALC_PREVIOUSKEYTYPE = "func";
	QUICKCALC_SHOWNTEXT = currText;
	quick_calc_showntext:SetText(QUICKCALC_SHOWNTEXT);
end

function quick_calc_numkey(key)
	currText = QUICKCALC_SHOWNTEXT;

	if (QUICKCALC_PREVIOUSKEYTYPE=="none" or QUICKCALC_PREVIOUSKEYTYPE=="num" or QUICKCALC_PREVIOUSKEYTYPE=="state")then
		if (currText == "0") then
			currText = "";
		end	
	
		currText = currText .. key;
	else
		currText = key;
	end

	QUICKCALC_PREVIOUSKEYTYPE = "num";

	QUICKCALC_SHOWNTEXT = currText;
	quick_calc_showntext:SetText(QUICKCALC_SHOWNTEXT);
end

function quick_calc_showntext_click(button, ignoreShift)
	if ( button == "LeftButton" ) then
		if ( IsShiftKeyDown() and not ignoreShift ) then
			if ( ChatFrameEditBox:IsVisible() ) then
				ChatFrameEditBox:Insert(QUICKCALC_SHOWNTEXT);
			end
		end
	end
end

function ToGSC(decimal, std)
	local gold = 0;
	local silver = 0;
	local copper = 0;

	if (std == "gold") then
		copper = math.mod(decimal, .01);
		decimal = decimal - copper;
		copper = copper * 10000

		silver = math.mod(decimal, 1);
		decimal = decimal - silver;
		silver = silver * 100;

		gold = decimal;
	elseif (std == "silver") then
		copper = math.mod(decimal, 1);
		decimal = decimal - copper;
		copper = copper * 100;

		silver = math.mod(decimal, 100);
		decimal = decimal - silver;

		gold = decimal / 100;
	else
		copper = math.mod(decimal, 100);
		decimal = decimal - copper;

		silver = math.mod(decimal, 10000);
		decimal = decimal - silver;
		silver = silver / 100;

		gold = decimal / 10000;
	end

	local temp = "";

	if (gold > 0) then
		temp = temp .. gold .. "g";
	end
	if (silver > 0 or (gold > 0 and copper > 0)) then
		temp = temp .. silver .. "s";
	end
	if (copper > 0) then
		temp = temp .. copper .. "c";
	end

	return temp;
end

function FromGSC(gold, silver, copper)
	if (gold == nil) then
		return "";
	end

	local total = 0;

	if (type(gold) == "string" and (not silver or type(silver) == "nil") and (not copper or type(copper) == "nil")) then
		local temp = gold;
		
		golds,golde = string.find(temp, "%d*%.?%d*g");
		if (golds == nil) then
			gold = 0;
		else
			gold = string.sub(temp, golds, golde - 1);
		end
		--ChatFrame1:AddMessage("bleh g:" .. gold);
	
		silvers,silvere = string.find(temp, "%d*%.?%d*s");
		if (silvers == nil) then
			silver = 0;
		else
			silver = string.sub(temp, silvers, silvere - 1);
		end
		--ChatFrame1:AddMessage("bleh s:" .. silver);

		coppers,coppere = string.find(temp, "%d*c");
		if (coppers == nil) then
			copper = 0;
		else
			copper = string.sub(temp, coppers, coppere - 1);
		end
	end

	total = total + copper;
	total = total + (silver * 100);
	total = total + (gold * 10000);

	return "" .. total;
end